#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLMULTTRANSPOSEMATRIXDPROC glMultTransposeMatrixd;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 }; /* ֡ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ľܸ */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* Ķ */

/*
** ޥƥꥢ
*/
static const GLfloat kdiff[] = { 0.0, 0.1, 0.3, 1.0 };  /* Ȼȿͷ */
static const GLfloat kspec[] = { 0.6, 0.6, 0.6, 1.0 };  /* ȿͷ */
static const GLfloat knone[] = { 0.0, 0.0, 0.0, 1.0 };  /* ȿ̵ */
static const GLfloat kshi = 20.0;                       /*  */

/*
** ƥ
*/
#define TEXWIDTH  128                      /* ƥ */
#define TEXHEIGHT 128                      /* ƥι⤵ */
static const char *textures[] = {          /* ƥե̾ */
  "room2nx.raw",
  "room2ny.raw",
  "room2nz.raw",
  "room2px.raw",
  "room2py.raw",
  "room2pz.raw",
};
static const int target[] = {           /* ƥΥå̾ */
  GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
  GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
  GL_TEXTURE_CUBE_MAP_POSITIVE_X,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
  GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
};

/*
** ȿ͸
*/
static void specular(float fx, float fy, float fz, const float l[], GLubyte col[])
{
  /* ٥ȥȿͥ٥ȥѤ */
  float lf = l[0] * fx + l[1] * fy + l[2] * fz;
  
  if (lf > 0.0) {
    /* ȿΨ255 */
    float rs = pow(lf, kshi) * 255.0;
    
    /* ȿ͸٤ */
    col[0] = (GLubyte)(kspec[0] * rs * lightcol[0]);
    col[1] = (GLubyte)(kspec[1] * rs * lightcol[1]);
    col[2] = (GLubyte)(kspec[2] * rs * lightcol[2]);
  }
  else {
    col[0] = col[1] = col[2] = 0;
  }
}

/*
** ƥκ
*/
static void makeTexture(GLubyte *tex[], int width, int height)
{
  int i = 0;
  
  /* ȿͥ٥ȥȸ٥ȥȤͤǥƥ */
  for (int v = 0; v < height; ++v) {
    float y = (float)(v + v - height) / (float)height;
    float y2 = y * y;
    
    for (int u = 0; u < width; ++u) {
      float x = (float)(u + u - width) / (float)width;
      float x2 = x * x;

      /* ȿͥ٥ȥ */
      float r = 1.0 / sqrt(x2 + y2 + 1.0);
      float s = x * r;
      float t = y * r;
      
      /* ̤ΥƥˤĤƤ줾ȿͶ٤ */
      specular(-r, -t,  s, lightpos, tex[0] + i);  /* negative x */
      specular( s, -r, -t, lightpos, tex[1] + i);  /* negative y */
      specular(-s, -t, -r, lightpos, tex[2] + i);  /* negative z */
      specular( r, -t, -s, lightpos, tex[3] + i);  /* positive x */
      specular( s,  r,  t, lightpos, tex[4] + i);  /* positive y */
      specular( s, -t,  r, lightpos, tex[5] + i);  /* positive z */
      
      i += 3;
    }
  }
}

/*
** 
*/
static void init(void)
{
  /* ƥɤ߹ߤ˻Ȥ */
  static GLubyte t[6][TEXHEIGHT * TEXWIDTH * 3];
  static GLubyte *texture[] = { t[0], t[1], t[2], t[3], t[4], t[5] };
  
  /* ƥκ */
  makeTexture(texture, TEXWIDTH, TEXHEIGHT);
  
  /* ƥϥХñ̤˵ͤޤƤ */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  
  for (int i = 0; i < 6; ++i) {
#if 0
    /* ƥɤ߹ߤ˻Ȥ */
    GLubyte texture[TEXHEIGHT][TEXWIDTH][4];
    FILE *fp;
    
    /* ƥɤ߹ */
    if ((fp = fopen(textures[i], "rb")) != NULL) {
      fread(texture, sizeof texture, 1, fp);
      fclose(fp);
    }
    else {
      perror(textures[i]);
    }
#endif
    
    /* ƥγ */
    glTexImage2D(target[i], 0, GL_RGB, TEXWIDTH, TEXHEIGHT, 0,
      GL_RGB, GL_UNSIGNED_BYTE, texture[i]);
  }
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* ƥĶ */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);
  
  /* 塼֥ޥåԥѤΥƥɸ*/
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  
  /*  */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ν */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
  
#if defined(WIN32)
  glMultTransposeMatrixd =
    (PFNGLMULTTRANSPOSEMATRIXDPROC)wglGetProcAddress("glMultTransposeMatrixd");
#endif
}

/* Ȣؿ */
#include "box.h"

/*
** 
*/
static void scene(void)
{
#if 0
  static const GLfloat color[] = { 1.0, 1.0, 1.0, 1.0 };  /*  () */
#endif
  
  /*  */
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, kdiff);
  glMaterialfv(GL_FRONT, GL_SPECULAR, knone);
  
  /* ƥޥåԥ󥰳 */
  glEnable(GL_TEXTURE_CUBE_MAP);
  
  /* ƥɸμưͭˤ */
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  
#if 0
  /* Ȣ */
  box(1.0, 1.0, 1.0);
#else
  /* ƥݥåȤ */
  glutSolidTeapot(1.0);
#endif
  
  /* ƥɸμư̵ˤ */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  
  /* ƥޥåԥ󥰽λ */
  glDisable(GL_TEXTURE_CUBE_MAP);
}


/****************************
** GLUT ΥХåؿ **
****************************/

/* ȥåܡѴؿ */
#include "trackball.h"

static void display(void)
{
  /* ƥѴ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  
  /* ȥåܡˤž */
  glMultTransposeMatrixd(trackballRotation());
  
  /* ǥӥ塼Ѵ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ΰ֤ */
  glPushMatrix();
  glMultMatrixd(trackballRotation());
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  glPopMatrix();
  
  /* ΰưʪΤ˰ư*/
  glTranslated(0.0, 0.0, -3.0);
  
#if 0
  /* ȥåܡˤž */
  glMultMatrixd(trackballRotation());
#endif
  
  /* ̥ꥢ */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /*  */
  scene();
  
  /* ֥Хåե */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* ȥåܡ뤹ϰ */
  trackballRegion(w, h);
  
  /* ɥΤӥ塼ݡȤˤ */
  glViewport(0, 0, w, h);
  
  /* ƩѴλ */
  glMatrixMode(GL_PROJECTION);
  
  /* ƩѴν */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ̤ؤ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* ȥåܡ볫 */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* ȥåܡ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* ȥåܡư */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q 򥿥פ齪λ */
    exit(0);
  default:
    break;
  }
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
